<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\State;
use App\StateAprobacion;
use App\Persona;
use App\Usuarios;
use App\Especialidad;
use App\Sede;
use App\TipoEspecialidad;
use App\TipoSede;
use App\PersonAseguradora;
use App\Aseguradora;
use App\Reportes;

class AdminController extends Controller
{
    // vista principal
    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function index(){
        return view('admin.index');
    }
    public function indexlistuser(){
        return view('admin.listauser');
    }
    public function indexcrearaseguradora(){
        return view('admin.crearaseguradora');
    }
    public function indexcrearsede(){
        return view('admin.crearsede');
    }
    public function indexmedicos(){
        return view('admin.crearmedicos');
    }
    public function indexasistente(){
        return view('admin.crearasistente');
    }
    public function indexreportes(){
        return view('admin.crearreportes');
    }
     // vista crear a las usuarios de la app
    // --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function indexcrearusers(){
        return view('admin.crearusers');
    }
    // listar las solicitudes a los administradores
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function listarSolicitudes(){
        if (!$request->ajax()) return redirect('/');

        $data_consult = Solicitudes::join('state','solicitudes.id_state','=','state.id')
        ->join('state_aprobacion','solicitudes.id_state_aprobacion','=','state_aprobacion.id')
        ->join('departamento','solicitudes.id_departamento','=','departamento.id')
        // ->join('detalle_solicitud','solicitudes.id_detalle_solicitud','=','detalle_solicitud.id')
        ->select('solicitudes.cod_solicitud','solicitudes.nombre','solicitudes.fecha_ini','solicitudes.fecha_fin_desing','solicitudes.fecha_fin_client','departamento.nombre as dnombre', 'state.nombre as snombre')
        ->orderBy('solicitudes.created_at','desc')
        ->get();
        return['solicitudes'=>$data_consult];
    }

   

    // verificar los usuarios que se crean 
    //-------------------------------------------------------------------------------------------------------------------

    public function checkuser(Request $request){
        $data = Usuarios::where('email','=',$request->user)->get();
        if(sizeof($data)>0){
            return ['dataResult'=> true];
        }
        return ['dataResult'=> false];
    }
    // peticion post para guardar un usuario
    // --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function crearadmin(Request $request){
        if (!$request->ajax()) return redirect('/');
        $dataProfesions = '';
           
        try {
            DB::beginTransaction();
             // guadar persona
             $data = $request;
             $persona = new Persona();
             $persona->nombres = $request->nombres;
             $persona->apellidos = $request->apellidos;
             $persona->telefono = $request->telefono;
             $persona->correo = $request->correo;
             $persona->estado_registro = 1;
             $persona->save();
             // guardar usuario
             $user = new Usuarios();
             $user->id_user = $persona->id;
             $user->email = $request->usuario;
             $user->password = bcrypt($request->password);
             $user->generica = $request->generica;
             $user->estado_registro = 1;
             $user->idrol = $request->rol;
             $user->id_user_create=$request->session()->get('id_persona');
             $user->save();
             // mensaje 
            DB::commit();
        } catch (\Exception $e) {
            DB::rollback();
        }
        return "Guardo correctamente";
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function listEspeandSede(){
        $data_Esp = TipoEspecialidad::select('*')->get();
        $data_Sed = TipoSede::select('*')->get();
        return ['sede'=>$data_Sed,'especialidad'=>$data_Esp];
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function saveEspecialidad(Request $request){
        if (!$request->ajax()) return redirect('/');
        $especi = new TipoEspecialidad();
        $especi->nombre = $request->especialidad;
        $especi->state = 1;
        $especi->save();
        return ['save'=>true];
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function saveSede(Request $request){
        if (!$request->ajax()) return redirect('/');
        $especi = new TipoSede();
        $especi->nombre = $request->sede;
        $especi->state = 1;
        $especi->save();
        return ['save'=>true];
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function creardoctor(Request $request){
        if (!$request->ajax()) return redirect('/');
        $dataProfesions = '';
            try {
                DB::beginTransaction();
                // guadar persona
                $data = $request;
                $persona = new Persona();
                $persona->nombres = $request->nombres;
                $persona->apellidos = $request->apellidos;
                $persona->telefono = $request->telefono;
                $persona->correo = $request->correo;
                $persona->estado_registro = 1;
                $persona->save();
                // guardar usuario
                $user = new Usuarios();
                $user->id_user = $persona->id;
                $user->email = $request->usuario;
                $user->password = bcrypt($request->password);
                $user->generica = $request->generica;
                $user->estado_registro = 1;
                $user->idrol = $request->rol;
                $user->id_user_create=$request->session()->get('id_persona');
                $user->save();
                // guardar especialidad del usuario
                $especi = new Especialidad();
                $especi->id_persona = $persona->id;
                $especi->id_especialidad = $request->especialidad;
                $especi->save();
                // guardar sede del usuario
                $sede = new Sede();
                $sede->id_persona = $persona->id;
                $sede->id_sede = $request->sede;
                
                $sede->save();
                
                DB::commit();
            } catch (Exception $e) {
                DB::rollback();
            }
            
            // mensaje 
            return "Guardo correctamente";
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function crearasistente(Request $request){
        if (!$request->ajax()) return redirect('/');
        $dataProfesions = '';
            try {
                DB::beginTransaction();
                // guadar persona
                $data = $request;
                $persona = new Persona();
                $persona->nombres = $request->nombres;
                $persona->apellidos = $request->apellidos;
                $persona->telefono = $request->telefono;
                $persona->correo = $request->correo;
                $persona->estado_registro = 1;
                $persona->save();
                // guardar usuario
                $user = new Usuarios();
                $user->id_user = $persona->id;
                $user->email = $request->usuario;
                $user->password = bcrypt($request->password);
                $user->generica = $request->generica;
                $user->estado_registro = 1;
                $user->idrol = $request->rol;
                $user->id_user_create=$request->session()->get('id_persona');
                $user->save();
                // guardar sede del usuario
                $sede = new Sede();
                $sede->id_persona = $persona->id;
                $sede->id_sede = $request->sede;
                $sede->save();
                DB::commit();
            } catch (\Throwable $th) {
                DB::rollback();
            }
            // mensaje 
            return "Guardo correctamente";
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function crearpaciente(Request $request){
        if (!$request->ajax()) return redirect('/');
        $dataProfesions = '';
            try {
                DB::beginTransaction();
                // guadar persona
                $data = $request;
                $persona = new Persona();
                $persona->identificacion = $request->ndoc;
                $persona->tipoidentificacion = $request->tipodoc;
                $persona->nombres = $request->nombres;
                $persona->apellidos = $request->apellidos;
                $persona->telefono = $request->telefono;
                $persona->correo = $request->correo;
                $persona->entidad = $request->entidad;
                $persona->estado_registro = 1;
                $persona->save();
                // guardar usuario
                $user = new Usuarios();
                $user->id_user = $persona->id;
                $user->email = $request->usuario;
                $user->password = bcrypt($request->password);
                $user->generica = $request->generica;
                $user->estado_registro = 1;
                $user->idrol = $request->rol;
                $user->id_user_create=$request->session()->get('id_persona');
                $user->save();
                $guardo = true;
                DB::commit();
            } catch (\Throwable $th) {
                $guardo=false;
                DB::rollback();
            }
            // mensaje 
            return ['save'=>$guardo];
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function listAseguradora(){
        $data = Aseguradora::where('id','<>',3)->select('*')->get();
        return ['aseguradora'=>$data];
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function saveAseguradora(Request $request){
        if (!$request->ajax()) return redirect('/');
        $especi = new Aseguradora();
        $especi->nombre = $request->aseguradora;
        $especi->nit = $request->nit;
        $especi->state = 1;
        $especi->save();
        return ['save'=>true];
    }
     // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
     public function crearuseraseguradora(Request $request){
        if (!$request->ajax()) return redirect('/');
        $dataProfesions = '';
            try {
                DB::beginTransaction();
                // guadar persona
                
                $persona = new Persona();
                $persona->nombres = $request->nombres;
                $persona->apellidos = $request->apellidos;
                $persona->telefono = $request->telefono;
                $persona->correo = $request->correo;
                $persona->estado_registro = 1;
                $persona->save();
                // guardar usuario
                $user = new Usuarios();
                $user->id_user = $persona->id;
                $user->email = $request->usuario;
                $user->password = bcrypt($request->password);
                $user->generica = $request->generica;
                $user->estado_registro = 1;
                $user->idrol = $request->rol;
                $user->id_user_create = $request->session()->get('id_persona');
                $user->save();

                //aseguradora
                $aseguradora = new PersonAseguradora();
                $aseguradora->id_persona = $persona->id;
                $aseguradora->id_aseguradora = $request->aseguradora;
            
                $aseguradora->save();
                DB::commit();
            } catch (\Throwable $th) {
                DB::rollback();
            }
            // mensaje 
            return "Guardo correctamente";
    }
    //--------------------------------------------------------------------------------------------------------------
    public function listUsuarios(Request $request){
        $data = Usuarios::join('personas','users.id_user','=','personas.id')
        ->join('tipo_usuario','users.idrol','=','tipo_usuario.id')
        ->select('tipo_usuario.nombre','users.email','users.id','users.password','users.generica','users.estado_registro as state','personas.*')->get();
        return ['usuario'=>$data];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function savePassword(Request $request){
        $password = Usuarios::where('id_user','=',$request->id_user)->get();
        $password[0]->email = $request->user;
        if(!empty($request->password)){
            $password[0]->password = bcrypt($request->password);
            $password[0]->generica = 1;
        }
        $password[0]->save();
        return ['usuario'=>true];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function deleteUser(Request $request){
        $delete = Usuarios::where('id_user','=',$request->id_user)->get();
        $delete[0]->estado_registro = 2;
        $delete[0]->save();
        return ['usuario'=>true];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function activeUser(Request $request){
        $delete = Usuarios::where('id_user','=',$request->id_user)->get();
        $delete[0]->estado_registro = 1;
        $delete[0]->save();
        return ['usuario'=>true];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function listAseguradoras(){
        $aseguradora = Aseguradora::where('id','<>',3)->select('*')->get();
        return ['aseguradoras'=>$aseguradora];
    }
    //---------------------------------------------------------------------------------------------------------
    public function saveEditaseg(Request $request){
        $aseg = Aseguradora::where('id','=',$request->id_aseg)->get();
        $aseg[0]->nombre = $request->aseguradora;
        $aseg[0]->nit = $request->nit;
        $aseg[0]->save();
        return ['aseg'=>true];
    }
     //----------------------------------------------------------------------------------------------------------------
     public function deleteAseguradora(Request $request){
        $delete = Aseguradora::where('id','=',$request->id_aseg)->get();
        $delete[0]->state = 2;
        $delete[0]->save();
        return ['usuario'=>true];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function activeAseguradora(Request $request){
        $delete = Aseguradora::where('id','=',$request->id_aseg)->get();
        $delete[0]->state = 1;
        $delete[0]->save();
        return ['usuario'=>true];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function listSedes(){
        $sede = TipoSede::select('*')->get();
        return ['sede'=>$sede];
    }
    //-----------------------------------------------------------------------------------------------------------------
    public function saveEditsede(Request $request){
        $sede = TipoSede::where('id','=',$request->id_sede)->get();
        $sede[0]->nombre = $request->sede;
        $sede[0]->save();
        return ['sede'=>true];
    }
     //----------------------------------------------------------------------------------------------------------------
     public function deleteSede(Request $request){
        $delete = TipoSede::where('id','=',$request->id_sede)->get();
        $delete[0]->state = 2;
        $delete[0]->save();
        return ['usuario'=>true];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function activeSede(Request $request){
        $delete = TipoSede::where('id','=',$request->id_sede)->get();
        $delete[0]->state = 1;
        $delete[0]->save();
        return ['usuario'=>true];
    }
    // lista de medicos
    //-----------------------------------------------------------------------------------------------------------
    public function ListMedicos(){
        $medic = Usuarios::join('personas','users.id_user','=','personas.id')
        ->join('person_sede','users.id_user','=','person_sede.id_persona')
        ->join('person_especialidad','users.id_user','=','person_especialidad.id_persona')
        ->where('users.idrol','=',2)
        ->where('users.estado_registro','=',1)
        ->select('users.id_user','users.email','users.estado_registro as state','personas.nombres','personas.apellidos',
        'personas.telefono','personas.correo','personas.direccion', 'person_especialidad.id_especialidad as especialidad','person_sede.id_sede as sede')->get();
        return['medicos'=>$medic];
    }
    public function saveEditmedicos(Request $request){
        try {
            DB::beginTransaction();
            $medicPerson = Persona::where('id','=',$request->id_medico)->get();
            $medicPerson[0]->nombres = $request->nombres;
            $medicPerson[0]->apellidos = $request->apellidos;
            $medicPerson[0]->correo = $request->correo;
            $medicPerson[0]->save();

            $medicEspe = Especialidad::where('id_persona','=',$medicPerson[0]->id)->get();
            $medicEspe[0]->id_especialidad = $request->especialidad;
            $medicEspe[0]->save();

            $medicSede = Sede::where('id_persona','=',$medicPerson[0]->id)->get();
            $medicSede[0]->id_sede = $request->sede;
            $medicSede[0]->save();

            $medicUser = Usuarios::where('id_user','=',$medicPerson[0]->id)->get();
            $medicUser[0]->email = $request->usuario;
            if(!empty($request->password)){
                $medicUser[0]->password = bcrypt($request->password);
                $medicUser[0]->generica = 1;
            }
            $medicUser[0]->save();
            DB::commit();
            $val = true;
        } catch (\Throwable $th) {
            //throw $th;
            $val = false;
            DB::rollback();
        }
        return['save'=>$val];
    }
    //----------------------------------------------------------------------------------------------------------
    public function ListAsis(){
        $asis = Usuarios::join('personas','users.id_user','=','personas.id')
        ->join('person_sede','users.id_user','=','person_sede.id_persona')
        ->join('person_especialidad','users.id_user','=','person_especialidad.id_persona')
        ->where('users.idrol','=',3)
        ->where('users.estado_registro','=',1)
        ->select('users.id_user','users.email','users.estado_registro as state','personas.nombres','personas.apellidos',
        'personas.telefono','personas.correo','personas.direccion', 'person_especialidad.id_especialidad as especialidad','person_sede.id_sede as sede')->get();
        return['asistentes'=>$asis];
    }
    //---------------------------------------------------------------------------------------------------------------
    public function saveEditasistentes(Request $request){
        try {
            DB::beginTransaction();
            $medicPerson = Persona::where('id','=',$request->id_asistente)->get();
            $medicPerson[0]->nombres = $request->nombres;
            $medicPerson[0]->apellidos = $request->apellidos;
            $medicPerson[0]->correo = $request->correo;
            $medicPerson[0]->save();

            $medicSede = Sede::where('id_persona','=',$medicPerson[0]->id)->get();
            $medicSede[0]->id_sede = $request->sede;
            $medicSede[0]->save();

            $medicUser = Usuarios::where('id_user','=',$medicPerson[0]->id)->get();
            $medicUser[0]->email = $request->usuario;
            if(!empty($request->password)){
                $medicUser[0]->password = bcrypt($request->password);
                $medicUser[0]->generica = 1;
            }
            
            $medicUser[0]->save();
            DB::commit();
            $val = true;
        } catch (\Throwable $th) {
            //throw $th;
            $val = false;
            DB::rollback();
        }
        return['save'=>$val];
    }
//---------------------------------------------------------------------------------------------------------------
// crear reportes 
//---------------------------------------------------------------------------------------------------------------
public function createReports(Request $request){
    if(isset($_FILES["archivo"]["name"]))
    {
        
            
            $file_names = $_FILES["archivo"]["name"];
            
            $original_file_name = pathinfo($file_names, PATHINFO_FILENAME);
            $file_type = explode(".", $file_names); $extension = end($file_type);
            if($extension == "docx"){
                $url_file = "../public/filePaciente/word/".$original_file_name.".".$extension;
                $urlFile = "/filePaciente/word/".$original_file_name.".".$extension;
            }else if($extension=="pdf"){
                $url_file = "../public/filePaciente/pdf/".$original_file_name.".".$extension;
                $urlFile = "/filePaciente/pdf/".$original_file_name.".".$extension;
            }
           
                try{
                    DB::beginTransaction();
                        $reports = new Reportes();
                        $reports->id_paciente = $request->paciente;
                        $reports->codigo = date('YmdGi');
                        $reports->id_person_upload = $request->session()->get('id_persona');
                        $reports->id_person_atendido = $request->medico;
                        $reports->nombre_file = $original_file_name;
                        $reports->url_file = $urlFile;
                        $reports->extension = ".".$extension;
                        $reports->estado_view = 1;
                        $reports->state = 1;
                        $reports->save();
                        $bool = true;
                    DB::commit();
                } catch(Exception $e){
                    $bool = false;
                    $error = $e;
                    DB::rollback();
                }
            
            move_uploaded_file($_FILES["archivo"]["tmp_name"], $url_file);
        
        return ['save'=>$bool];
    }
}
//----------------------------------------------------------------------------------------------------------------
public function ListReportes(){
    $dataReports = Reportes::join('personas as p1','reportes.id_paciente','=','p1.id')
    ->join('personas as p2','reportes.id_person_upload','=','p2.id')
    ->join('personas as p3','reportes.id_person_atendido','=','p3.id')
    ->join('state_aprobacion','reportes.estado_view','=','state_aprobacion.id')
    ->select('reportes.created_at as fecha','reportes.id','reportes.codigo',
    'p1.nombres','p1.apellidos','p2.nombres as nombreupload','reportes.url_file',
    'reportes.extension','state_aprobacion.nombre as estado','reportes.state',
    'reportes.nombre_file','p3.nombres as atendido')
    ->get();
    return ['reportes'=>$dataReports];
}
  //----------------------------------------------------------------------------------------------------------------
    public function deleteReporte(Request $request){
        $delete = Reportes::where('id','=',$request->id_reporte)->get();
        $delete[0]->state = 2;
        $delete[0]->save();
        return ['usuario'=>true];
    }
//----------------------------------------------------------------------------------------------------------------
    public function activeReporte(Request $request){
        $delete = Reportes::where('id','=',$request->id_reporte)->get();
        $delete[0]->state = 1;
        $delete[0]->save();
        return ['usuario'=>true];   
    }
//-----------------------------------------------------------------------------------------------------------------------
    public function searchPaciente(Request $request){
        $persona = Persona::join('users as u','personas.id','=','u.id_user')
        ->where('personas.identificacion','=',$request->cedula)
        ->where('u.estado_registro','=',1)
        ->select('personas.*')->get();
        return ['pacientes'=>$persona];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function saveEditReporte(Request $request){
        if (!$request->ajax()) return redirect('/');
        $reports = Reportes::where('id','=', $request->id_reporte)->get();
        $file_names=""; $original_file_name=""; $extension=""; $url_file="";$boolFile =false;
        $urlFile="";
        if(isset($_FILES["archivo"]["name"]))
        {
                $file_names = $_FILES["archivo"]["name"];
                $original_file_name = pathinfo($file_names, PATHINFO_FILENAME);
                $file_type = explode(".", $file_names); $extension = end($file_type);
                if($extension == "docx"){
                    $url_file = "../public/filePaciente/word/".$original_file_name.".".$extension;
                    $urlFile = "/filePaciente/word/".$original_file_name.".".$extension;
                }else if($extension=="pdf"){
                    $url_file = "../public/filePaciente/pdf/".$original_file_name.".".$extension;
                    $urlFile = "/filePaciente/pdf/".$original_file_name.".".$extension;
                }
                move_uploaded_file($_FILES["archivo"]["tmp_name"], $url_file);
                $boolFile = true;
        }
        try{
            DB::beginTransaction();
                $reports[0]->id_paciente = $request->paciente;
                $reports[0]->id_person_atendido = $request->medico;
                if($boolFile)
                {
                    $reports[0]->nombre_file = $original_file_name;
                    $reports[0]->url_file = $urlFile;
                    $reports[0]->extension = ".".$extension;
                }
                $reports[0]->save();
                $bool = true;
            DB::commit();
        } catch(Exception $e){
            $bool = false;
            $error = $e;
            DB::rollback();
        }
       return ['save'=>$bool];

    }
}
