<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\State;
use App\StateAprobacion;
use App\Persona;
use App\Usuarios;
use App\Especialidad;
use App\Sede;
use App\TipoEspecialidad;
use App\TipoSede;
use App\PersonAseguradora;
use App\Aseguradora;
use App\Reportes;

class PacienteController extends Controller
{
    // Vista Principal
    //--------------------------------------------------------------------------------------------------------------
    public function index(){
        return view('paciente.index');
    }
    //----------------------------------------------------------------------------------------------------------------
    public function ListReportes(Request $request){
        $dataReports = Reportes::join('personas as p3','reportes.id_person_atendido','=','p3.id')
        ->join('state_aprobacion','reportes.estado_view','=','state_aprobacion.id')
        ->where('reportes.state','=',1)
        ->where('reportes.id_paciente','=',$request->session()->get('id_persona'))
        ->select('reportes.created_at as fecha','reportes.id','reportes.codigo'
        ,'reportes.url_file','reportes.extension','state_aprobacion.nombre as estado'
        ,'reportes.state','p3.nombres as nombres','p3.apellidos as apellidos')
        ->get();
        return ['reportes'=>$dataReports];
    }
}