<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\User;
use App\Persona;
use App\Usuarios;
use App\TipoDocumento;
use Illuminate\Support\Facades\Mail as Mail;

class UsuarioController extends Controller
{
    // vista principal de usuarios administradores (Ejemplo de como se debe usar)
    // ---------------------------------------------------------------------------------------------------------------------------------------
    public function index()
    {
        return view('administradores.index');
    }
    
    // eliminar tildes de la cadena que viene por url (Ejemplo).
    // ----------------------------------------------------------------------------------------------------------------------------------------
    public function eliminarTildes($cadena)
    {

        //Codificamos la cadena en formato utf8 en caso de que nos de errores
        // $cadena = utf8_encode($cadena);
    
        //Ahora reemplazamos las letras
        $cadena = str_replace(
            array('á', 'à', 'ä', 'â', 'ª', 'Á', 'À', 'Â', 'Ä'),
            array('a', 'a', 'a', 'a', 'a', 'A', 'A', 'A', 'A'),
            $cadena );
    
        $cadena = str_replace(
            array('é', 'è', 'ë', 'ê', 'É', 'È', 'Ê', 'Ë'),
            array('e', 'e', 'e', 'e', 'E', 'E', 'E', 'E'),
            $cadena );
    
        $cadena = str_replace(
            array('í', 'ì', 'ï', 'î', 'Í', 'Ì', 'Ï', 'Î'),
            array('i', 'i', 'i', 'i', 'I', 'I', 'I', 'I'),
            $cadena );
    
        $cadena = str_replace(
            array('ó', 'ò', 'ö', 'ô', 'Ó', 'Ò', 'Ö', 'Ô'),
            array('o', 'o', 'o', 'o', 'O', 'O', 'O', 'O'),
            $cadena );
    
        $cadena = str_replace(
            array('ú', 'ù', 'ü', 'û', 'Ú', 'Ù', 'Û', 'Ü'),
            array('u', 'u', 'u', 'u', 'U', 'U', 'U', 'U'),
            $cadena );
    
        $cadena = str_replace(
            array('ç', 'Ç'),
            array('c', 'C'),
            $cadena
        );
        return $cadena;
    }

    // guardar usuario de la app (sin uso). solo ejemplo 
    // ----------------------------------------------------------------------------------------------------------------------------------------------
    public function store(Request $request)
    {
        if (!$request->ajax()) return redirect('/');

        $dataProfesions = '';
        try{
            DB::beginTransaction();
            $data = $request;
            $persona = new Persona();
            $persona->primer_nombre = "andres";
            $persona->segundo_nombre = 'felipe';
            $persona->primer_apellido = 'gutierrez';
            $persona->segundo_apellido = 'machado';
            $persona->telefono = '3042478283';
            $persona->estado_registro = 1;
            $persona->save();
    
            $user = new Usuarios();
            $user->id_user = $persona->id;
            $user->email = 'andresg9602@hotmail.com';
            $user->password = bcrypt('123456');
            $user->estado_registro = 1;
            $user->idrol = 2;
            $user->save();
            // mensaje 
            var_dump("Guardo correctamente");
            DB::commit();
        } catch (Exception $e){
            // DB::rollBack();
            var_dump($e);
        }
    }
   
    // ejemplo de como enviar un correo electronico
    // ---------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function enviarcorreo(Request $request){
        $destino = $request->correo;
        $usuario = $request->usuario;
        $mensaje = $request->mensaje;
        $data = array('mensaje' => $mensaje, 'usuario'=>$usuario);
        Mail::send('Emails.recuperar',$data, function($msj) use ($destino){
            $msj->subject('Codigo de recuperación');
            $msj->to($destino);
        });
        return ['response'=>'se ha enviado el mensaje'];
       
    }
    // ************************************************************************************************************************************
    
    
    // |--------------------------------------------------------------------------------------------------
    // |       Codigo editable 
    // |---------------------------------------------------------------------------------------------------

    // recuperar cuenta
    public function recuperar(Request $request){
        // consulta para ver si el usuario existe
        // --------------------------------------------------------------
        $data_consult_user = Persona::where('email_recover','=',$request->correo)->get();
        if(sizeof($data_consult_user)>0)
        {
            // crear el codigo
            // ------------------
            $codigo = date("Hs");
            
            // enviamos el codigo por correo
            // -----------------------------
            $correoDestino = $data_consult_user[0]->email_recover;
            $usuario = $data_consult_user[0]->primer_nombre;
            $data = array('mensaje' => $codigo, 'usuario'=>$usuario);
            Mail::send('Emails.recuperar',$data, function($msj) use ($correoDestino){
                $msj->subject('Codigo de recuperación');
                $msj->to($correoDestino);
            });
            // retornamos estos datos
            // ---------------------------------------------------------
            return ['bool'=>true, 'codigo'=>$codigo, 'time'=>'00:02:00', 'persona'=> $data_consult_user[0]->id];
        }else{
            return ['bool'=>false];
        }
    }
    // codigo para enviar correo
    // --------------------------------------------------------------------------------------------------------
    public function enviarcorreos($correoDestino, $usuario, $codigo){
        $data = array('mensaje' => $codigo, 'usuario'=>$usuario);
        Mail::send('Emails.recuperar',$data, function($msj) use ($correoDestino){
            $msj->subject('Codigo de recuperación');
            $msj->to($correoDestino);
        });
        return ['response'=>'se ha enviado el mensaje'];
       
    }

    // guardar contraseña nueva
    // ---------------------------------------------------------------------------------------------------------
    public function savePass(Request $request){
        try{
            $user = Usuarios::where('id_user','=',$request->idperson)->get();
            DB::beginTransaction();
            $user[0]->password = bcrypt($request->password);
            $user[0]->save();
            echo "Se ha guardado correctamente.";
            DB::commit();
        }catch(Exception $e)
        {
            DB::rollBack();
        }
        
    }
    // verific ar contraseña
    //------------------------------------------------------------------------------------------------------
    public function verfiPass(Request $request){
        $data = Usuarios::where('id_user','=',$request->session()->get('id_persona'))->where('generica','=',1)->get();
        if(sizeof($data)>0)
        {
            return ['cambiar'=>true];
        }
        return['cambiar'=>false];
    }
     //--------------------------------------------------------------------------------------------------------
     public function saveEditpassword(Request $request){
        $usuario = Usuarios::where('id_user','=',$request->session()->get('id_persona'))->get();
        $usuario[0]->password = bcrypt($request->password);
        $usuario[0]->generica = 0;
        $usuario[0]->save();
        return ['save'=>true];
    }
    // fin del controlador
    // ----------------------------------------------------------------------------------------------------------------------------------------------------------------
 
}
