/**
 * First we will load all of this project's JavaScript dependencies which
 * includes Vue and other libraries. It is a great starting point when
 * building robust, powerful web applications using Vue and Laravel.
 */

require('./bootstrap');

window.Vue = require('vue');

/**
 * The following block of code may be used to automatically register your
 * Vue components. It will recursively scan this directory for the Vue
 * components and automatically register them with their "basename".
 *
 * Eg. ./components/ExampleComponent.vue -> <example-component></example-component>
 */

// const files = require.context('./', true, /\.vue$/i);
// files.keys().map(key => Vue.component(key.split('/').pop().split('.')[0], files(key).default));
// Vue.component('inicio-categoria',require('./components/Inicio/Categoria.vue').default);
/**
 * Next, we will create a fresh Vue application instance and attach it to
 * the page. Then, you may begin adding components to this application
 * or customize the JavaScript scaffolding to fit your unique needs.
 */

// //////////////////////////////////////////////////////////////////////////////////////////////////////////////

// vista de la pagina principal
Vue.component('login',require('./components/login/login.vue').default);
Vue.component('recuperar-password',require('./components/login/recuperarpass.vue').default);

// *****************************************************************************************************************
// Cambio de Password
Vue.component('cambiar-password',require('./components/CambiarPassword/index.vue').default);
//***********************************************************************************************************************

// vista paciente

Vue.component('paciente-panel',require('./components/paciente/panel.vue').default);
Vue.component('paciente-panel-crear-reporte',require('./components/paciente/VerReporte/index.vue').default);

// *****************************************************************************************************************

// vista para el doctor

Vue.component('medico-panel',require('./components/medico/panel.vue').default);
Vue.component('medico-panel-crear-reporte',require('./components/medico/CrearReporte/index.vue').default);
Vue.component('medico-panel-crear-paciente-reporte',require('./components/medico/CrearReporte/crearreporte.vue').default);
Vue.component('medico-panel-buscar-paciente',require('./components/medico/CrearReporte/viewpacientes.vue').default);
Vue.component('medico-panel-crear-user-paciente',require('./components/medico/CrearPaciente/crearpaciente.vue').default);
Vue.component('medico-panel-crear-aseguradora',require('./components/medico/CrearAseguradora/crearaseguradora.vue').default);
Vue.component('medico-panel-detalle-reporte',require('./components/medico/DetalleReporte/detallereporte.vue').default);

// *****************************************************************************************************************

// vista para el asistente

Vue.component('asistente-panel',require('./components/asistente/panel.vue').default);
Vue.component('asistente-panel-crear-reporte',require('./components/asistente/CrearReporte/index.vue').default);
Vue.component('asistente-panel-crear-paciente-reporte',require('./components/asistente/CrearReporte/crearreporte.vue').default);
Vue.component('asistente-panel-buscar-paciente',require('./components/asistente/CrearReporte/viewpacientes.vue').default);
Vue.component('asistente-panel-crear-user-paciente',require('./components/asistente/CrearPaciente/crearpaciente.vue').default);
Vue.component('asistente-panel-crear-aseguradora',require('./components/asistente/CrearAseguradora/crearaseguradora.vue').default);
Vue.component('asistente-panel-detalle-reporte',require('./components/asistente/DetalleReporte/detallereporte.vue').default);

//***********************************************************************************************************************

// vista aseguradora

Vue.component('aseguradora-panel',require('./components/aseguradora/panel.vue').default);
Vue.component('aseguradora-panel-crear-reporte',require('./components/aseguradora/VerReporte/index.vue').default);
// *************************************************************************************************************************

// vista para el administrador
Vue.component('admin-panel',require('./components/admin/panel.vue').default);
Vue.component('admin-panel-crear-user',require('./components/admin/CrearUsuarios/index.vue').default);
Vue.component('admin-panel-crear-user-admin',require('./components/admin/CrearUsuarios/CrearAdmin/craeradmin.vue').default);
Vue.component('admin-panel-crear-user-aseguradora',require('./components/admin/CrearUsuarios/CrearAseguradora/crearausersegura.vue').default);
Vue.component('admin-panel-crear-user-doctor',require('./components/admin/CrearUsuarios/CrearDoctor/creardoctor.vue').default);
Vue.component('admin-panel-crear-user-asistente',require('./components/admin/CrearUsuarios/CrearAsistente/crearasistente.vue').default);
Vue.component('admin-panel-crear-user-paciente',require('./components/admin/CrearUsuarios/CrearPaciente/crearpaciente.vue').default);
Vue.component('admin-panel-crear-especialidad',require('./components/admin/CrearEspecialidad/crearespecialidad.vue').default);
Vue.component('admin-panel-crear-sede',require('./components/admin/CrearSede/crearsede.vue').default);
Vue.component('admin-panel-crear-aseguradora',require('./components/admin/CrearAseguradora/crearaseguradora.vue').default);
Vue.component('admin-panel-lista-usuario',require('./components/admin/listUsuarios.vue').default);
Vue.component('admin-panel-detalle-usuario',require('./components/admin/DetalleUsuario/detalleusuario.vue').default);
Vue.component('admin-panel-view-aseguradora',require('./components/admin/CrearAseguradora/index.vue').default);
Vue.component('admin-panel-detalle-aseguradora',require('./components/admin/DetalleAseguradora/detalleaseguradora.vue').default);
Vue.component('admin-panel-view-sede',require('./components/admin/CrearSede/index.vue').default);
Vue.component('admin-panel-view-aseguradora',require('./components/admin/CrearAseguradora/index.vue').default);
Vue.component('admin-panel-detalle-sede',require('./components/admin/DetalleSede/detallesede.vue').default);
Vue.component('admin-panel-view-medicos',require('./components/admin/CrearUsuarios/CrearDoctor/index.vue').default);
Vue.component('admin-panel-lista-medicos',require('./components/admin/CrearUsuarios/CrearDoctor/index.vue').default);
Vue.component('admin-panel-detalle-medicos',require('./components/admin/DetalleUsuario/DetalleMedicos/detallemedicos.vue').default);
Vue.component('admin-panel-detalle-asistente',require('./components/admin/DetalleUsuario/DetalleAsistentes/detalleasistente.vue').default);
Vue.component('admin-panel-view-asistente',require('./components/admin/CrearUsuarios/CrearAsistente/index.vue').default);
Vue.component('admin-panel-view-reporte',require('./components/admin/CrearReporte/index.vue').default);
Vue.component('admin-panel-crear-paciente-reporte',require('./components/admin/CrearReporte/crearreporte.vue').default);
Vue.component('admin-panel-buscar-paciente',require('./components/admin/CrearReporte/viewpacientes.vue').default);
Vue.component('admin-panel-detalle-reporte',require('./components/admin/DetalleReporte/detallereporte.vue').default);


// ****************************************************************************************************************************

// Componentes Globales (errores, acciones, etc)

Vue.component('Error-Dreports',require('./components/error/ReportsofErrors.vue').default);
Vue.component('loguado',require('./components/home-app/backurl.vue').default);

// *****************************************************************************************************************


// Retornando vue al div (APP)
// ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
const app = new Vue({
    el: '#app',
});
