<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();
/*
|----------------------------------------------------------------------------
| vistas de la app
|----------------------------------------------------------------------------
|
*/
// ------------------------------------------------------------------------
//      Inicio de la pagina 
// ------------------------------------------------------------------------
//      Rutas web sin restricciones
// ------------------------------------------------------------------------
Route::group(['middleware'=>['web']], function(){
    //--------inicio app---------------------------
    // get
    Route::get('/',  'HomeController@index');
    Route::get('/login/registrarme', 'UsuarioController@store');
    Route::get('/recuperar-password', function(){return view('auth.passwords.recuperar');});
    Route::get('/cpanel/verificarpass',  'UsuarioController@verfiPass');
    Route::get('/chat-box','HomeController@chat');
    // post
    Route::post('/login', 'Auth\LoginController@login')->name('login');
    Route::post('/recuperar-password/email-validate','UsuarioController@recuperar');
    Route::post('/recuperar-password/save-password','UsuarioController@savePass');
    Route::post('/cpanel/save-edit-user-password','UsuarioController@saveEditpassword');
    Route::post('/logout', 'Auth\LoginController@logout')->name('logout');
});
Route::group(['middleware'=>['medicos']], function(){
    //--------Modulo Medicos---------------------------
    // get
    Route::get('/cpanel-medico',  'MedicoController@index');
    Route::get('/cpanel-medico/listar-reporte',  'MedicoController@ListReportes');
    Route::get('/cpanel-medico/listar-medicos',  'MedicoController@ListMedicos');
    Route::get('/cpanel-medico/listar-pacientes',  'MedicoController@searchPaciente');
    Route::get('/cpanel-medico/list-aseguradora',  'MedicoController@listAseguradora');
    Route::get('/cpanel-medico/check-sing-up',  'MedicoController@checkuser');
    Route::get('/cpanel-medico/filtrar',  'MedicoController@SearchListReportes');
    
    // post
    Route::post('/cpanel-medico/eliminar-reporte','MedicoController@deleteReporte');
    Route::post('/cpanel-medico/save-reporte',  'MedicoController@createReports');
    Route::post('/cpanel-medico/save-edit-reporte',  'MedicoController@saveEditReporte');
    Route::post('/cpanel-medico/save-paciente','MedicoController@crearpaciente');
    Route::post('/cpanel-medico/save-aseguradora','MedicoController@saveAseguradora');
});
Route::group(['middleware'=>['aseguradora']], function(){
    //--------Modulo clientes---------------------------
    // get
    Route::get('/cpanel-aseguradora',  'AseguradoraController@index');
    Route::get('/cpanel-aseguradora/listar-reporte',  'AseguradoraController@ListReportes');
    // post
    Route::post('/cpanel-aseguradora/save-edit-state-reporte',  'AseguradoraController@saveEditstateReports');

});
Route::group(['middleware'=>['asistentes']], function(){
   //--------Modulo Medicos---------------------------
    // get
    Route::get('/cpanel-asistente',  'AsistenteController@index');
    Route::get('/cpanel-asistente/listar-reporte',  'AsistenteController@ListReportes');
    Route::get('/cpanel-asistente/listar-medicos',  'AsistenteController@ListMedicos');
    Route::get('/cpanel-asistente/listar-pacientes',  'AsistenteController@searchPaciente');
    Route::get('/cpanel-asistente/list-aseguradora',  'AsistenteController@listAseguradora');
    Route::get('/cpanel-asistente/check-sing-up',  'AsistenteController@checkuser');
    Route::get('/cpanel-asistente/filtrar',  'AsistenteController@SearchListReportes');
    
    // post
    Route::post('/cpanel-asistente/eliminar-reporte','AsistenteController@deleteReporte');
    Route::post('/cpanel-asistente/save-reporte',  'AsistenteController@createReports');
    Route::post('/cpanel-asistente/save-paciente','AsistenteController@crearpaciente');
    Route::post('/cpanel-asistente/save-aseguradora','AsistenteController@saveAseguradora');
    Route::post('/cpanel-asistente/save-edit-reporte',  'AsistenteController@saveEditReporte');
});
Route::group(['middleware'=>['pacientes']], function(){
    //--------Modulo Pacientes---------------------------
    // get
    Route::get('/cpanel-paciente',  'PacienteController@index');
    Route::get('/cpanel-paciente/listar-reporte',  'PacienteController@ListReportes');

    // post
   // Route::post('/cpanel-design/save-fecha',  'DesignController@saveFechaentrega');
});

//----------------------------------------------------------------------------------
Route::group(['middleware'=>['admin']], function(){
    //--------Modulo administradores---------------------------
    // get
    Route::get('/cpanel-administration',  'AdminController@index');
    Route::get('/cpanel-administration/usuarios',  'AdminController@indexcrearusers');
    Route::get('/cpanel-administration/aseguradora',  'AdminController@indexcrearaseguradora');
    Route::get('/cpanel-administration/medicos',  'AdminController@indexmedicos');
    Route::get('/cpanel-administration/asistentes',  'AdminController@indexasistente');
    Route::get('/cpanel-administration/sede',  'AdminController@indexcrearsede');
    Route::get('/cpanel-administration/reportes',  'AdminController@indexreportes');
    Route::get('/cpanel-administration/lista-usuarios',  'AdminController@indexlistuser');
    Route::get('/cpanel-administration/check-sing-up',  'AdminController@checkuser');
    Route::get('/cpanel-administration/list-espe-y-sede',  'AdminController@listEspeandSede');
    Route::get('/cpanel-administration/list-aseguradora',  'AdminController@listAseguradora');
    Route::get('/cpanel-administration/listar-user',  'AdminController@listUsuarios');
    Route::get('/cpanel-administration/listar-aseguradoras',  'AdminController@listAseguradoras');
    Route::get('/cpanel-administration/listar-sedes',  'AdminController@listSedes');
    Route::get('/cpanel-administration/listar-medicos',  'AdminController@ListMedicos');
    Route::get('/cpanel-administration/listar-asistentes',  'AdminController@ListAsis');
    Route::get('/cpanel-administration/listar-reporte',  'AdminController@ListReportes');
    Route::get('/cpanel-administration/listar-pacientes',  'AdminController@searchPaciente');

    // post

    Route::post('/cpanel-administration/save-users',  'AdminController@crearadmin');
    Route::post('/cpanel-administration/save-especialidad',  'AdminController@saveEspecialidad');
    Route::post('/cpanel-administration/save-sede',  'AdminController@saveSede');
    Route::post('/cpanel-administration/save-doctor','AdminController@creardoctor');
    Route::post('/cpanel-administration/save-asistente','AdminController@crearasistente');
    Route::post('/cpanel-administration/save-paciente','AdminController@crearpaciente');
    Route::post('/cpanel-administration/save-aseguradora','AdminController@saveAseguradora');
    Route::post('/cpanel-administration/save-user-aseguradora','AdminController@crearuseraseguradora');
    Route::post('/cpanel-administration/save-user-password','AdminController@savePassword');
    Route::post('/cpanel-administration/eliminar-user','AdminController@deleteUser');
    Route::post('/cpanel-administration/active-user','AdminController@activeUser');
    Route::post('/cpanel-administration/save-edit-aseguradora',  'AdminController@saveEditaseg');
    Route::post('/cpanel-administration/eliminar-aseguradora','AdminController@deleteAseguradora');
    Route::post('/cpanel-administration/active-aseguradora','AdminController@activeAseguradora');
    Route::post('/cpanel-administration/save-edit-sede','AdminController@saveEditsede');
    Route::post('/cpanel-administration/eliminar-sede','AdminController@deleteSede');
    Route::post('/cpanel-administration/active-sede','AdminController@activeSede');
    Route::post('/cpanel-administration/save-edit-medico','AdminController@saveEditmedicos');
    Route::post('/cpanel-administration/save-edit-asistente','AdminController@saveEditasistentes');
    Route::post('/cpanel-administration/save-reporte',  'AdminController@createReports');
    Route::post('/cpanel-administration/eliminar-reporte','AdminController@deleteReporte');
    Route::post('/cpanel-administration/active-reporte','AdminController@activeReporte');
    Route::post('/cpanel-admin/save-edit-reporte',  'AdminController@saveEditReporte');
    // Route::get('/Home/listSolicitud',  'AdminController@listarSolicitudes');
});







